#!/usr/bin/perl

@input=<STDIN>;

# soluzione senza matrice, stampa output "al volo"

$i = 0; 
foreach $elem (@input) {
    chomp($elem);
    if ($elem eq '+-------+-------+-------+') {
        next;
    }
    @val = split(' ',$elem);
    $j=0;
    foreach $N (@val) {
        if ($N =~ /[1-9]/) {
            print "$i,$j,$N\n";
            $j++;
        }
        elsif ($N eq '.') {
            $j++;
        }    
    }
    $i++;
}

# soluzione senza matrice, uso di un vettore
$i=0;
foreach $elem (@input) {
    chomp($elem);
    if ($elem eq '+-------+-------+-------+') {
        next;
    }
    @val = split(' ',$elem);
    foreach $N (@val) {
        if ($N =~ /[.,1-9]/) {
            $vettore[$i] = $N;
            $i++;
        }    
    }
}

for ($k = 0; $k < @vettore; $k++) {
    if ($vettore[$k] ne '.') {
        $i=int($k/9); 
        $j = $k%9;
        if ($vettore[$k] =~ /[1-9]/) {
            print "$i,$j,$vettore[$k]\n";
        }
    }
}

# soluzione con matrice

$i=0;
foreach $elem (@input) {
    chomp($elem);
    if ($elem eq '+-------+-------+-------+') {
        next;
    }
    @val = split(' ',$elem);
    $j=0;
    foreach $N (@val) {
        if ($N ne '|') {
            $matrice[$i][$j] = $N; 
            $j++
        }
    }
    $i++;
}

for ($i = 0; $i < 9; $i++) {
	for ($j = 0; $j < 9; $j++) {
		if ($matrice[$i][$j] =~ /[1-9]/) {
			print "$i,$j,$matrice[$i][$j]\n";
		}
	}
}

