#!/usr/bin/perl

open(FILE1,"$ARGV[0]");
open(FILE2,"$ARGV[1]");

@f_ijn = <FILE1>;
if (@f_ijn[0] eq "+-------+-------+-------+\n") {
    @f_grafico = @f_ijn;
    @f_ijn = <FILE2>;
}
else {
    @f_grafico = <FILE2>;
}

# soluzione senza matrice, stampa output "al volo"

$i = 0; 
foreach $elem_grafico (@f_grafico) {
    chomp($elem_grafico);
    if ($elem_grafico eq "+-------+-------+-------+") {
        print "$elem_grafico\n";
        next;
    }
    @val_grafico = split(' ',$elem_grafico);
    $j=0;
    foreach $N (@val_grafico) {
        if ($N =~ /[.,1-9]/) {
            $trovato = 0;
            foreach $elem_ijn (@f_ijn) {
                chomp($elem_ijn);
                @val_ijn = split(',',$elem_ijn);
                if ($i eq $val_ijn[0] && $j eq $val_ijn[1]) {
                    $trovato = 1;
                    if ($val_ijn[2] eq $N) {
                        print "$N ";
                    }
                    else {
                        if ($N ne '.') {
                            print '* ';
                        }
                        else {
                            print "$val_ijn[2] ";
                        }
                    }
                }
            }
            if ($trovato == 0) {
                print "$N ";
            }
            $j++;
        } 
        else {
            if ( $j == 9) {
                print "$N\n";
            }
            else {
                print "$N ";
            }
        }   
    }
    $i++;
}

# soluzione senza matrice, uso di un vettore

foreach $elem (@f_ijn) {
    chomp($elem);
    @val = split(',',$elem);
    $indice = $val[0]*9+$val[1];
    @v_ijn[$indice] = $val[2];
}

$i=0;
foreach $elem (@f_grafico) {
    chomp($elem);
    if ($elem eq '+-------+-------+-------+') {
        next;
    }
    @val = split(' ',$elem);
    foreach $N (@val) {
        if ($N =~ /[.,1-9]/) {
            $v_grafico[$i] = $N;
            $i++;
        }    
    }
}

for ($i = 0; $i < 9; $i++) {
    if ( $i % 3 == 0) {
        print "+-------+-------+-------+\n";
    }
    for ($j = 0; $j < 9; $j++) {
        if ( $j % 3 == 0) {
            print "| ";
        }
        $indice = $i*9+$j;
        if ($v_ijn[$indice] eq '' && $v_grafico[$indice] eq '.') {
            print '. ';
        }
        elsif ($v_ijn[$indice] =~ /[1-9]/ && $v_grafico[$indice] eq '.') {
            print "$v_ijn[$indice] ";
        }
        elsif ($v_ijn[$indice] eq '' && $v_grafico[$indice] =~ /[1-9]/) {
            print "$v_grafico[$indice] ";
        }
        elsif ($v_ijn[$indice] =~ /[1-9]/ && $v_grafico[$indice] =~ /[1-9]/) {
            if ($v_ijn[$indice] == $v_grafico[$indice]) {
                print "$v_grafico[$indice] ";
            }
            else {
                print '* ';
            }
        }
    }
    print "|\n";
}
print "+-------+-------+-------+\n";


# soluzione con matrice

foreach $elem (@f_ijn) {
    chomp($elem);
    @val = split(',',$elem);
    $m_ijn[$val[0]][$val[1]] = $val[2]; 
}

$i=0;
foreach $elem (@f_grafico) {
    chomp($elem);
    if ($elem eq '+-------+-------+-------+') {
        next;
    }
    @val = split(' ',$elem);
    $j=0;
    foreach $N (@val) {
        if ($N =~ /[.,1-9]/) {
            $m_grafico[$i][$j] = $N; 
            $j++;
        }    
    }
    $i++;
}

for ($i = 0; $i < 9; $i++) {
    if ( $i % 3 == 0) {
        print "+-------+-------+-------+\n";
    }
    for ($j = 0; $j < 9; $j++) {
        if ( $j % 3 == 0) {
            print "| ";
        }
        $indice = $i*9+$j;
        if ($m_ijn[$i][$j] eq '' && $m_grafico[$i][$j] eq '.') {
            print '. ';
        }
        elsif ($m_ijn[$i][$j] =~ /[1-9]/ && $m_grafico[$i][$j] eq '.') {
            print "$m_ijn[$i][$j] ";
        }
        elsif ($m_ijn[$i][$j] eq '' && $m_grafico[$i][$j] =~ /[1-9]/) {
            print "$m_grafico[$i][$j] ";
        }
        elsif ($m_ijn[$i][$j] =~ /[1-9]/ && $m_grafico[$i][$j] =~ /[1-9]/) {
            if ($m_ijn[$i][$j] == $m_grafico[$i][$j]) {
                print "$m_grafico[$i][$j] ";
            }
            else {
                print '* ';
            }
        }
    }
    print "|\n";
}
print "+-------+-------+-------+\n";

