#ifndef BUFFER_H
#define BUFFER_H

#include "Ordine.h"
#include<iostream>
using namespace std;

class Buffer
{
 public:

 Buffer(int dim);
 bool isFull();
 bool isEmpty();
 bool isPresent(int codiceOrdine);
 //Inserisce una ordinazione per una data quantita di un tipo di pizza, rispettando l'ordine FIFO
 void putFIFO(int codicePizza, int codiceOrdine, int quantita);
 Ordine getFIFO();
 //Deposita una ordinazione per una data quantita di un tipo di pizza (il metodo  utilizzato per
 //depositare una certa 'quantita' di pizze aventi un codice pari a 'codicePizza' nel
 //banco delle pizze non-FIFO).
 void put(int codicePizza, int codiceOrdine, int quantita);
 //Cancella l'ordinazione con codice 'cod' (il metodo  utilizzato al momento del prelievo di un ordinativo
 //di pizze aventi codice di ordinazione pari a 'cod' per cancellare l'ordinazione appena esaudita)
 void clean(int cod);

 private:
	int dim;
	Ordine * ordini;
	int in,out;
	int occupati;
 };

#endif

