#!/usr/bin/perl

@input=<STDIN>;

# soluzione senza matrice, stampa output "al volo"

for ($i = 0 ; $i < 9; $i++) {
    if ($i % 3 == 0) {
        print "+-------+-------+-------+\n";
    }
    for ($j = 0 ; $j < 9; $j++) {
        if ($j % 3 == 0) {
            print "| ";
        }
        $trovato=0;
        foreach $elem (@input) {
            chomp($elem);
            @val = split(',',$elem);
            if (($val[0] eq $i) && ($val[1] eq $j)) {
                print "$val[2] ";
                $trovato=1;
                last;
            }
        }
        if ($trovato == 0) {
            print ". ";
        }
    }
    print "|\n";
}
print "+-------+-------+-------+\n";

# soluzione senza matrice, uso di un vettore

foreach $elem (@input) {
    chomp($elem);
    @val = split(',',$elem);
    $indice = $val[0]*9+$val[1];
    @vettore[$indice] = $val[2];
}

for ($i = 0; $i < 81; $i++) {
    if ($i % 27 == 0) {
        print "+-------+-------+-------+\n";
    }
    if ($i == 0 || $i % 3 == 0) {
        print "| ";
    }
    if ($vettore[$i] =~ /[1-9]/) {
        print "$vettore[$i] ";    
    }
    else {
        print ". ";
    }
    if ($i % 9 == 8) {
        print "|\n";
    }
}
print "+-------+-------+-------+\n";

# soluzione con matrice

foreach $elem (@input) {
    chomp($elem);
    @val = split(',',$elem);
    $matrice[$val[0]][$val[1]] = $val[2]; 
}

for ($i = 0; $i < 9; $i++) {
	if ($i % 3 == 0) { 
		print "+-------+-------+-------+\n";
	}
	#print "| ";
	for ($j = 0; $j < 9; $j++) {
		if ($j % 3 == 0) {
			print "| ";
		}
		if ($matrice[$i][$j] =~ /[1-9]/) {
			print $matrice[$i][$j] . " ";
		}
		else {
			print ". ";
		}
		
	}
	print "|\n";
}
print "+-------+-------+-------+\n";


